
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         scgrammerparse
#define yylex           scgrammerlex
#define yyerror         scgrammererror
#define yylval          scgrammerlval
#define yychar          scgrammerchar
#define yydebug         scgrammerdebug
#define yynerrs         scgrammernerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "scgrammer.y"

/******************************************************************************
 * DESCRIPTION: SystemC bison parser
 *
 * This file is part of SystemC-Perl.
 *
 * Author: Wilson Snyder <wsnyder@wsnyder.org>
 *
 * Code available from: http://www.veripool.org/systemperl
 *
 ******************************************************************************
 *
 * Copyright 2001-2010 by Wilson Snyder.  This program is free software;
 * you can redistribute it and/or modify it under the terms of either the GNU
 * Lesser General Public License Version 3 or the Perl Artistic License Version 2.0.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 *****************************************************************************/

#include "scparse.h"
#include "scgrammer.h"
#define YYERROR_VERBOSE
#define SCFree(p) {if (p) free(p); p=NULL;}

extern /*const*/ char *sclextext;
int scgrammerdebug = 0;
extern int sclexleng;

/* Join two strings, return result */
char *scstrjoin2ss (char *a, char *b) {
    int len = strlen(a)+strlen(b);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b);
    SCFree (a); SCFree (b);
    return (cp);
}

/* Join two strings, return result */
char *scstrjoin2si (char *a, const char *b) {
    int len = strlen(a)+strlen(b);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b);
    SCFree (a); /*SCFree (b);*/
    return (cp);
}

/* Join two strings, return result */
char *scstrjoin2is (const char *a, char *b) {
    int len = strlen(a)+strlen(b);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b);
    /*SCFree (a);*/ SCFree (b);
    return (cp);
}

/* Join three strings, middle one constant, return result */
char *scstrjoin3iii (const char *a, const char *b, const char *c) {
    int len = strlen(a)+strlen(b)+strlen(c);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b); strcat(cp,c);
    /*SCFree (a);*/ /*SCFree (b);*/ /*SCFree (c);*/
    return (cp);
}

/* Join three strings, middle one constant, return result */
char *scstrjoin3sis (char *a, const char *b, char *c) {
    char *cp=scstrjoin3iii(a,b,c);
    SCFree (a); /*SCFree (b);*/ SCFree (c);
    return (cp);
}

char *scstrjoin4iiii (const char *a, const char *b, const char *c, const char *d) {
    int len = strlen(a)+strlen(b)+strlen(c)+strlen(d);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b); strcat(cp,c); strcat(cp,d);
    /*SCFree (a);*/ /*SCFree (b);*/ /*SCFree (c);*/ /*SCFree (d);*/
    return (cp);
}

char *scstrjoin4sisi (char *a, const char *b, char *c, const char* d) {
    char *cp=scstrjoin4iiii(a,b,c,d);
    SCFree (a); /*SCFree (b);*/ SCFree (c); /*ScFree(d);*/
    return (cp);
}

/* Emit all text including this parsed token */

int scgrammerlex() {
    int toke;
    sclex_include_switch ();
    toke = sclexlex();
    if (toke != SP && toke != AUTO) {	// Strip #sp.... from text sections, AUTOs do it separately
	scparser_PrefixCat(sclextext,sclexleng);
    }
#ifdef FLEX_DEBUG
    if (sclex_flex_debug) {
	fprintf(stderr,"ln%d: GOT %d: '%s'\n", scParserLex.lineno, toke,
		DENULL(sclextext));
    }
#endif
    return (toke);
};



/* Line 189 of yacc.c  */
#line 191 "scgrammer.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 1
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     STRING = 258,
     SYMBOL = 259,
     NUMBER = 260,
     PP = 261,
     SP = 262,
     COLONCOLON = 263,
     CLASS = 264,
     CONST = 265,
     ENUM = 266,
     PRIVATE = 267,
     PROTECTED = 268,
     PUBLIC = 269,
     VIRTUAL = 270,
     AUTO = 271,
     NCSC_MODULE = 272,
     SC_MODULE = 273,
     SC_SIGNAL = 274,
     SC_INOUT_CLK = 275,
     SC_CLOCK = 276,
     SC_CTOR = 277,
     SC_MAIN = 278,
     SP_CELL = 279,
     SP_CELL_DECL = 280,
     SP_MODULE_CONTINUED = 281,
     SP_PIN = 282,
     SP_TEMPLATE = 283,
     SP_TRACED = 284,
     SP_UI = 285,
     SP_COVERGROUP = 286,
     SP_COVER_SAMPLE = 287,
     COVERPOINT = 288,
     CG_PAGE = 289,
     CG_DESCRIPTION = 290,
     CG_OPTION = 291,
     CG_DEFAULT = 292,
     CG_BINS = 293,
     CG_ILLEGAL_BINS = 294,
     CG_ILLEGAL_BINS_FUNC = 295,
     CG_IGNORE_BINS = 296,
     CG_IGNORE_BINS_FUNC = 297,
     CG_LIMIT_FUNC = 298,
     CG_AUTO_ENUM_BINS = 299,
     CG_CROSS = 300,
     CG_ROWS = 301,
     CG_COLS = 302,
     CG_TABLE = 303,
     CG_WINDOW = 304,
     VL_SIG = 305,
     VL_SIGW = 306,
     VL_INOUT = 307,
     VL_INOUTW = 308,
     VL_IN = 309,
     VL_INW = 310,
     VL_OUT = 311,
     VL_OUTW = 312
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 112 "scgrammer.y"

  char *string;



/* Line 214 of yacc.c  */
#line 290 "scgrammer.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 302 "scgrammer.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  144
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   573

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  89
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  74
/* YYNRULES -- Number of rules.  */
#define YYNRULES  239
/* YYNRULES -- Number of states.  */
#define YYNSTATES  533

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   312

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    73,    74,
      75,    76,    77,    78,    79,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    81,    80,    82,    83,     2,    84,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    86,    85,    87,    88,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    41,    43,    45,    47,    49,    51,    53,    55,    57,
      59,    61,    63,    65,    67,    69,    71,    73,    75,    77,
      80,    82,    84,    86,    88,    90,    92,    94,    96,    98,
     100,   102,   104,   106,   108,   110,   112,   114,   116,   118,
     120,   122,   124,   126,   128,   130,   132,   134,   136,   138,
     140,   142,   144,   146,   148,   150,   152,   154,   156,   158,
     160,   162,   164,   166,   168,   170,   175,   177,   182,   186,
     192,   199,   203,   207,   211,   215,   219,   223,   226,   228,
     232,   234,   238,   240,   243,   246,   250,   252,   257,   259,
     263,   265,   268,   271,   275,   280,   286,   294,   306,   314,
     324,   336,   338,   340,   342,   345,   347,   351,   353,   355,
     360,   367,   369,   376,   381,   385,   388,   392,   394,   396,
     400,   406,   408,   410,   412,   416,   419,   422,   425,   429,
     434,   439,   444,   451,   456,   461,   466,   468,   470,   473,
     478,   484,   489,   494,   500,   505,   512,   519,   526,   528,
     531,   534,   540,   542,   547,   555,   566,   580,   585,   587,
     589,   593,   595,   597,   599,   606,   608,   610,   613,   616,
     622,   632,   634,   639,   642,   648,   651,   653,   655,   658,
     664,   667,   673,   679,   690,   703,   714,   727,   738,   751,
     762,   775,   781,   786,   788,   789,   791,   795,   798,   801,
     802,   804,   806,   810,   815,   817,   821,   823,   826,   827,
     829,   831,   834,   838,   839,   843,   845,   847,   851,   853
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      90,     0,    -1,    93,    -1,    58,    -1,    59,    -1,    60,
      -1,    61,    -1,    62,    -1,    63,    -1,    64,    -1,    65,
      -1,    66,    -1,    67,    -1,    68,    -1,    69,    -1,    70,
      -1,    71,    -1,    72,    -1,    73,    -1,    74,    -1,    75,
      -1,    76,    -1,    77,    -1,    78,    -1,    79,    -1,    80,
      -1,    81,    -1,    82,    -1,    83,    -1,    84,    -1,    85,
      -1,    86,    -1,    87,    -1,    88,    -1,     8,    -1,    14,
      -1,    12,    -1,    13,    -1,    94,    -1,    93,    94,    -1,
      95,    -1,    96,    -1,    97,    -1,   105,    -1,   106,    -1,
     107,    -1,   108,    -1,   110,    -1,   145,    -1,    34,    -1,
      35,    -1,    36,    -1,    37,    -1,    38,    -1,    39,    -1,
      40,    -1,    41,    -1,    42,    -1,    43,    -1,    44,    -1,
      45,    -1,    46,    -1,    47,    -1,    48,    -1,    49,    -1,
     147,    -1,   109,    -1,   148,    -1,   117,    -1,   118,    -1,
     119,    -1,   120,    -1,   115,    -1,    98,    -1,   149,    -1,
       3,    -1,     4,    -1,     5,    -1,     6,    -1,    10,    -1,
      91,    -1,    92,    -1,    15,    -1,    17,    -1,    16,    -1,
      18,    65,     4,    66,    -1,    23,    -1,    26,    65,     4,
      66,    -1,     9,   103,    86,    -1,     9,   103,    73,    99,
      86,    -1,     9,   103,    73,    14,    17,    86,    -1,     9,
     103,    74,    -1,     9,   103,    77,    -1,     9,   103,    69,
      -1,     9,   103,   103,    -1,     9,   103,    67,    -1,     9,
     103,    66,    -1,     9,    86,    -1,   100,    -1,   100,    73,
      99,    -1,   101,    -1,   101,    69,   100,    -1,   102,    -1,
      92,   102,    -1,    15,   102,    -1,    15,    92,   102,    -1,
     104,    -1,   104,    75,   100,    77,    -1,     4,    -1,     4,
       8,     4,    -1,   103,    -1,   103,    67,    -1,    10,   103,
      -1,    10,   103,    67,    -1,    22,    65,     4,    66,    -1,
      24,    65,   156,    69,     4,    -1,    25,    65,     4,    69,
     156,    66,    74,    -1,    27,    65,   156,    69,     4,   160,
      69,     4,   160,    66,    74,    -1,    19,    75,   112,    77,
       4,   160,    74,    -1,    28,    65,   111,    69,     3,    69,
       3,    66,    74,    -1,    28,    65,   111,    69,     3,    69,
       3,    69,     3,    66,    74,    -1,     3,    -1,   156,    -1,
     113,    -1,   113,    67,    -1,   114,    -1,     4,     8,   113,
      -1,     4,    -1,   116,    -1,     4,    75,   161,    77,    -1,
       4,    75,   161,    69,   161,    77,    -1,   116,    -1,    30,
      75,   161,    69,   161,    77,    -1,    20,     4,   160,    74,
      -1,    21,     4,    74,    -1,    21,    65,    -1,    21,     4,
      65,    -1,     7,    -1,     5,    -1,     4,     8,     4,    -1,
      81,   121,    73,   121,    82,    -1,   121,    -1,   122,    -1,
     123,    -1,   124,    69,   123,    -1,    38,     4,    -1,    39,
       4,    -1,    41,     4,    -1,    81,    82,    76,    -1,    81,
       5,    82,    76,    -1,   125,    76,    37,    74,    -1,   125,
      76,   123,    74,    -1,   125,   126,    86,   124,    87,    74,
      -1,   125,   126,   122,    74,    -1,   125,   127,   122,    74,
      -1,    44,    76,     4,    74,    -1,   131,    -1,   128,    -1,
     129,   128,    -1,    35,    76,     3,    74,    -1,    36,     4,
      76,     5,    74,    -1,    34,    76,     3,    74,    -1,    35,
      76,     3,    74,    -1,    36,     4,    76,     5,    74,    -1,
      34,    76,     3,    74,    -1,    43,    76,     4,    65,    66,
      74,    -1,    42,    76,     4,    65,    66,    74,    -1,    40,
      76,     4,    65,    66,    74,    -1,   131,    -1,   132,   131,
      -1,    33,     4,    -1,    33,     4,    65,     4,    66,    -1,
      74,    -1,    81,     5,    82,    74,    -1,    81,     5,    82,
      86,   132,    87,    74,    -1,    81,     5,    82,    76,    81,
       5,    73,     5,    82,    74,    -1,    81,     5,    82,    76,
      81,     5,    73,     5,    82,    86,   132,    87,    74,    -1,
      86,   129,    87,    74,    -1,     4,    -1,   135,    -1,   136,
      69,   135,    -1,    46,    -1,    47,    -1,    48,    -1,   137,
      76,    86,   136,    87,    74,    -1,   131,    -1,   138,    -1,
     139,   138,    -1,    45,     4,    -1,    45,     4,    65,     4,
      66,    -1,    49,     4,    65,     4,    69,     4,    69,     5,
      66,    -1,    74,    -1,    86,   132,    87,    74,    -1,   133,
     134,    -1,   140,    86,   139,    87,    74,    -1,   141,   142,
      -1,   130,    -1,   143,    -1,   144,   143,    -1,   146,    65,
     144,    66,    74,    -1,    31,     4,    -1,    32,    65,     4,
      66,    74,    -1,    29,   112,     4,   160,    74,    -1,    50,
      65,     4,   157,    69,   162,    69,   162,    66,    74,    -1,
      51,    65,     4,   157,    69,   162,    69,   162,    69,   161,
      66,    74,    -1,    52,    65,     4,   157,    69,   162,    69,
     162,    66,    74,    -1,    53,    65,     4,   157,    69,   162,
      69,   162,    69,   161,    66,    74,    -1,    54,    65,     4,
     157,    69,   162,    69,   162,    66,    74,    -1,    55,    65,
       4,   157,    69,   162,    69,   162,    69,   161,    66,    74,
      -1,    56,    65,     4,   157,    69,   162,    69,   162,    66,
      74,    -1,    57,    65,     4,   157,    69,   162,    69,   162,
      69,   161,    66,    74,    -1,    11,   150,    86,   151,    87,
      -1,    11,   150,     4,    74,    -1,     4,    -1,    -1,   152,
      -1,   151,    69,   152,    -1,     4,   153,    -1,    76,   154,
      -1,    -1,     5,    -1,     4,    -1,     4,    65,    66,    -1,
       4,    65,   155,    66,    -1,   154,    -1,   155,    69,   154,
      -1,     4,    -1,     4,   158,    -1,    -1,   158,    -1,   159,
      -1,   158,   159,    -1,    81,   161,    82,    -1,    -1,    81,
     161,    82,    -1,     4,    -1,   162,    -1,     4,     8,     4,
      -1,     5,    -1,    70,     5,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   203,   203,   209,   209,   209,   209,   209,   209,   210,
     210,   210,   210,   210,   210,   211,   211,   211,   211,   211,
     211,   212,   212,   212,   212,   212,   212,   213,   213,   213,
     213,   213,   213,   214,   214,   217,   217,   217,   222,   223,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   272,   279,   280,   283,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   298,   299,
     302,   303,   306,   307,   308,   309,   312,   313,   316,   317,
     320,   321,   322,   323,   326,   329,   332,   335,   338,   342,
     344,   348,   349,   353,   354,   360,   361,   365,   366,   367,
     371,   380,   383,   392,   398,   404,   405,   408,   418,   419,
     422,   425,   426,   429,   430,   433,   434,   435,   438,   441,
     445,   446,   447,   448,   449,   450,   451,   454,   455,   462,
     463,   464,   468,   469,   470,   471,   472,   473,   476,   477,
     483,   484,   487,   488,   489,   490,   491,   492,   498,   501,
     502,   505,   506,   507,   510,   511,   514,   515,   518,   519,
     525,   528,   529,   535,   536,   537,   539,   542,   543,   546,
     549,   555,   561,   564,   567,   570,   573,   576,   579,   582,
     585,   593,   594,   596,   597,   599,   600,   602,   606,   607,
     609,   610,   611,   612,   614,   615,   620,   621,   624,   625,
     628,   629,   632,   638,   639,   642,   643,   644,   647,   648
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "SYMBOL", "NUMBER", "PP", "SP",
  "\"::\"", "CLASS", "CONST", "ENUM", "PRIVATE", "PROTECTED", "PUBLIC",
  "VIRTUAL", "AUTO", "NCSC_MODULE", "SC_MODULE", "SC_SIGNAL",
  "SC_INOUT_CLK", "SC_CLOCK", "SC_CTOR", "SC_MAIN", "SP_CELL",
  "SP_CELL_DECL", "SP_MODULE_CONTINUED", "SP_PIN", "SP_TEMPLATE",
  "SP_TRACED", "SP_UI", "SP_COVERGROUP", "SP_COVER_SAMPLE", "COVERPOINT",
  "CG_PAGE", "CG_DESCRIPTION", "CG_OPTION", "CG_DEFAULT", "CG_BINS",
  "CG_ILLEGAL_BINS", "CG_ILLEGAL_BINS_FUNC", "CG_IGNORE_BINS",
  "CG_IGNORE_BINS_FUNC", "CG_LIMIT_FUNC", "CG_AUTO_ENUM_BINS", "CG_CROSS",
  "CG_ROWS", "CG_COLS", "CG_TABLE", "CG_WINDOW", "VL_SIG", "VL_SIGW",
  "VL_INOUT", "VL_INOUTW", "VL_IN", "VL_INW", "VL_OUT", "VL_OUTW", "'!'",
  "'\"'", "'#'", "'$'", "'%'", "'&'", "'\\''", "'('", "')'", "'*'", "'+'",
  "','", "'-'", "'.'", "'/'", "':'", "';'", "'<'", "'='", "'>'", "'?'",
  "'@'", "'\\\\'", "'['", "']'", "'^'", "'`'", "'|'", "'{'", "'}'", "'~'",
  "$accept", "sourceText", "symbol", "clAccess", "expList", "exp", "auto",
  "module", "module_continued", "class", "clColList", "clList",
  "clSymAccess", "clSymParamed", "clSymScoped", "clSymRef", "ctor", "cell",
  "cell_decl", "pin", "decl", "pin_template", "string_or_cellname",
  "declType", "declType1", "declTypeBase", "decl_sp_ui", "type_sp_ui",
  "inout", "inout_clk", "inst_clk", "sp", "cpBinNumber", "cpBinRange",
  "cpBinValue", "cpBinValueList", "cpBinType", "cpBinMulti",
  "cpBinMultiNum", "coverpointBin", "coverpointBinList", "cgOpt", "cpOpt",
  "cpOptList", "coverpoint_head", "coverpoint_desc", "cross_item",
  "cross_item_list", "cross_start", "cross_entry", "cross_desc_list",
  "cross_head", "window_head", "window_desc", "coverpoint",
  "coverpointList", "covergroup", "covergroup_head", "coversample",
  "traceable", "enum", "enumSymbol", "enumValList", "enumVal",
  "enumAssign", "enumExpr", "enumFunParmList", "cellname", "vectorsE",
  "vectors_bra", "vector_bra", "vector", "vectorNum", "negNum", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    58,    59,    60,    61,    62,    63,    64,
      92,    91,    93,    94,    96,   124,   123,   125,   126
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    89,    90,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    92,    92,    92,    93,    93,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    95,    96,    96,    97,    98,    98,
      98,    98,    98,    98,    98,    98,    98,    98,    99,    99,
     100,   100,   101,   101,   101,   101,   102,   102,   103,   103,
     104,   104,   104,   104,   105,   106,   107,   108,   109,   110,
     110,   111,   111,   112,   112,   113,   113,   114,   114,   114,
     114,   115,   116,   117,   118,   119,   119,   120,   121,   121,
     122,   123,   123,   124,   124,   125,   125,   125,   126,   127,
     128,   128,   128,   128,   128,   128,   128,   129,   129,   130,
     130,   130,   131,   131,   131,   131,   131,   131,   132,   132,
     133,   133,   134,   134,   134,   134,   134,   134,   135,   136,
     136,   137,   137,   137,   138,   138,   139,   139,   140,   140,
     141,   142,   142,   143,   143,   143,   143,   144,   144,   145,
     146,   147,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   149,   149,   150,   150,   151,   151,   152,   153,   153,
     154,   154,   154,   154,   155,   155,   156,   156,   157,   157,
     158,   158,   159,   160,   160,   161,   161,   161,   162,   162
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     4,     3,     5,
       6,     3,     3,     3,     3,     3,     3,     2,     1,     3,
       1,     3,     1,     2,     2,     3,     1,     4,     1,     3,
       1,     2,     2,     3,     4,     5,     7,    11,     7,     9,
      11,     1,     1,     1,     2,     1,     3,     1,     1,     4,
       6,     1,     6,     4,     3,     2,     3,     1,     1,     3,
       5,     1,     1,     1,     3,     2,     2,     2,     3,     4,
       4,     4,     6,     4,     4,     4,     1,     1,     2,     4,
       5,     4,     4,     5,     4,     6,     6,     6,     1,     2,
       2,     5,     1,     4,     7,    10,    13,     4,     1,     1,
       3,     1,     1,     1,     6,     1,     1,     2,     2,     5,
       9,     1,     4,     2,     5,     2,     1,     1,     2,     5,
       2,     5,     5,    10,    12,    10,    12,    10,    12,    10,
      12,     5,     4,     1,     0,     1,     3,     2,     2,     0,
       1,     1,     3,     4,     1,     3,     1,     2,     0,     1,
       1,     2,     3,     0,     3,     1,     1,     3,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    75,    76,    77,    78,   137,    34,     0,    79,   214,
      36,    37,    35,    82,    84,    83,     0,     0,     0,     0,
       0,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,     0,     0,     0,
       0,     0,     0,     0,     0,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,     0,    80,    81,     2,
      38,    40,    41,    42,    73,    43,    44,    45,    46,    66,
      47,    72,   131,    68,    69,    70,    71,    48,     0,    65,
      67,    74,   108,    97,     0,   213,     0,     0,     0,   233,
       0,   135,     0,     0,     0,     0,     0,     0,   127,     0,
     123,   125,   128,     0,   200,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,    39,     0,     0,    96,    95,
      93,     0,    91,    92,    88,    94,     0,     0,     0,     0,
       0,     0,   136,   134,     0,   226,     0,     0,     0,     0,
     121,     0,   122,     0,     0,   233,   124,   235,   238,     0,
       0,   236,     0,   228,   228,   228,   228,   228,   228,   228,
     228,     0,     0,     0,     0,     0,     0,   196,     0,     0,
       0,   197,     0,   109,     0,    35,     0,     0,     0,    98,
     100,   102,   110,   106,   212,   219,     0,   215,    85,     0,
       0,   133,   114,     0,   227,   230,     0,     0,    87,     0,
       0,   126,     0,     0,     0,   239,     0,     0,     0,   229,
       0,     0,     0,     0,     0,     0,     0,   170,     0,     0,
       0,   188,     0,   172,     0,     0,   193,     0,   191,     0,
     195,     0,   198,   112,     0,     0,   104,   103,    89,     0,
       0,   111,     0,     0,   217,     0,   211,   233,   234,     0,
     231,   115,     0,   233,     0,     0,   129,   202,   237,     0,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   157,     0,   156,
     181,   182,   183,   185,     0,   186,     0,   168,     0,   199,
     113,    90,   105,    99,   101,     0,   221,   220,   218,   216,
       0,   232,     0,     0,     0,     0,   132,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   161,   159,     0,     0,
       0,     0,     0,     0,     0,   145,   146,     0,   147,     0,
       0,     0,     0,     0,     0,     0,     0,   158,     0,     0,
     187,     0,   169,   107,     0,   118,   116,     0,     0,   130,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   160,
     189,     0,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   138,     0,     0,   141,   142,     0,     0,
       0,     0,     0,     0,   177,     0,   194,   192,   222,   224,
       0,   233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   164,   162,     0,     0,     0,
       0,   155,     0,   150,     0,   151,     0,   148,   143,     0,
     153,   154,   178,   179,     0,   223,     0,     0,   119,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   163,     0,     0,     0,   139,     0,   149,     0,     0,
       0,     0,   225,     0,     0,   203,     0,   205,     0,   207,
       0,   209,     0,     0,     0,   174,   167,   166,   165,     0,
     144,   152,   180,   184,   117,   120,     0,     0,     0,     0,
     190,     0,   140,   204,   206,   208,   210,     0,   175,     0,
       0,     0,   176
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    86,    87,   207,    89,    90,    91,    92,    93,    94,
     208,   209,   210,   211,   212,   213,    95,    96,    97,    98,
      99,   100,   171,   129,   130,   131,   101,   132,   103,   104,
     105,   106,   416,   417,   418,   459,   316,   374,   375,   317,
     318,   197,   327,   328,   198,   256,   463,   464,   324,   325,
     326,   199,   200,   260,   201,   202,   107,   108,   109,   110,
     111,   116,   216,   217,   274,   338,   430,   166,   238,   239,
     225,   161,   180,   181
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -399
static const yytype_int16 yypact[] =
{
     315,  -399,  -399,  -399,  -399,  -399,  -399,     8,  -399,    33,
    -399,  -399,  -399,  -399,  -399,  -399,    -4,    -8,    69,    48,
      62,  -399,    81,   100,   102,   117,   119,    28,    95,   181,
     121,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,   130,   135,   136,
     140,   146,   152,   156,   158,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,   191,  -399,  -399,   315,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,   166,  -399,
    -399,  -399,   201,  -399,    23,  -399,    19,   236,    28,   160,
      -6,  -399,   238,   239,   240,   242,   239,    82,    27,   246,
     187,  -399,  -399,    37,  -399,   251,   252,   264,   265,   266,
     267,   268,   269,   270,  -399,  -399,   144,   271,  -399,  -399,
    -399,   184,  -399,  -399,  -399,  -399,   203,   274,   213,   204,
      37,   206,  -399,  -399,   216,   202,   215,   218,   219,   220,
    -399,   221,  -399,    28,    37,   160,  -399,   278,  -399,   283,
     222,  -399,   226,   202,   202,   202,   202,   202,   202,   202,
     202,   289,   223,   224,   290,   291,   292,  -399,   -26,   211,
     -30,  -399,   138,  -399,   294,   284,   235,    30,   228,   229,
     234,  -399,   237,   230,  -399,   231,   -38,  -399,  -399,   302,
     227,  -399,  -399,    37,   202,  -399,   304,   239,  -399,   306,
     309,  -399,    11,   330,   312,  -399,    37,   331,   279,   202,
     337,   338,   339,   340,   341,   342,   343,   348,   411,   412,
     344,   351,   352,  -399,   413,   194,  -399,   172,  -399,   217,
    -399,   345,  -399,   354,   336,    30,  -399,  -399,  -399,   212,
     212,  -399,   212,   159,  -399,   274,  -399,   160,  -399,   346,
    -399,  -399,   357,   160,   355,    37,  -399,  -399,  -399,   349,
    -399,    41,    41,    41,    41,    41,    41,    41,    41,   421,
     353,   356,   424,   427,   428,   358,   359,   360,   429,   430,
     433,   362,   435,   365,   366,   367,     3,  -399,    94,  -399,
    -399,  -399,  -399,  -399,   368,  -399,    35,  -399,   105,  -399,
    -399,  -399,  -399,  -399,  -399,   369,   380,  -399,  -399,  -399,
     373,  -399,   374,   381,   446,   375,  -399,   382,   384,   385,
     386,   387,   388,   389,   390,   394,  -399,  -399,   391,   395,
     393,   -29,   460,   461,   392,  -399,  -399,   462,  -399,   463,
     465,   466,     6,    21,    63,   396,   397,  -399,   398,   399,
    -399,   400,  -399,  -399,    25,  -399,  -399,   468,    57,  -399,
      41,    41,    41,    41,    41,    41,    41,    41,  -399,  -399,
    -399,   471,  -399,   401,   217,   402,   404,   474,   415,   416,
     418,   414,   477,  -399,   417,   171,  -399,  -399,   419,   405,
     410,    20,   420,   422,  -399,   485,  -399,  -399,  -399,  -399,
      88,   160,   423,   487,   426,   431,   432,   434,   436,   437,
     438,   439,   440,   490,   116,  -399,  -399,   425,   441,   444,
     445,  -399,   497,  -399,   442,  -399,   443,  -399,  -399,   -36,
    -399,  -399,  -399,  -399,   -33,  -399,   159,   447,  -399,   448,
     449,    37,   450,    37,   451,    37,   452,    37,   500,   454,
     455,  -399,   456,   457,   458,  -399,   171,  -399,    20,   459,
     485,   464,  -399,   467,   469,  -399,   470,  -399,   473,  -399,
     476,  -399,   478,   479,   507,  -399,  -399,  -399,  -399,   453,
    -399,  -399,  -399,  -399,  -399,  -399,   472,   475,   480,   481,
    -399,   482,  -399,  -399,  -399,  -399,  -399,   -24,  -399,   217,
     126,   483,  -399
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -399,  -399,  -399,     4,  -399,   484,  -399,  -399,  -399,  -399,
     247,  -117,  -399,  -141,    -2,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,   403,   347,  -399,  -399,     9,  -399,  -399,
    -399,  -399,  -387,  -232,  -382,  -399,  -399,  -399,  -399,   199,
    -399,  -399,  -254,  -398,  -399,  -399,    32,  -399,  -399,   192,
    -399,  -399,  -399,  -399,   326,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,   259,  -399,  -371,  -399,  -119,    77,   372,
    -186,  -173,  -160,  -276
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
     220,   319,   233,   323,    88,   114,   444,   169,   172,   102,
     412,   413,   112,   429,   232,   347,   348,   349,   350,   351,
     352,   353,   354,   156,   412,   413,   419,   112,   454,   336,
     337,   275,   128,   488,   112,   173,   490,   115,   280,   458,
     204,   177,   178,   414,   258,   402,   178,   403,   253,   276,
     528,   489,   120,   280,   491,   254,   259,   404,    28,   162,
     255,   117,   529,   279,   319,   266,   267,   118,   163,   306,
     307,   308,   323,   119,   382,   311,   289,   313,   314,   372,
     285,   320,   321,   322,   373,   170,   165,   415,   286,   148,
     149,   428,   150,    88,   113,   492,   151,   152,   102,   509,
     153,   415,   174,   420,   340,   157,   510,   179,   282,   154,
     343,   179,   155,   121,   434,   435,   436,   437,   438,   439,
     440,   441,   379,   432,   332,   345,   433,   122,   306,   307,
     308,   530,   309,   310,   311,   312,   313,   314,   315,   306,
     307,   308,   422,   423,   415,   311,   123,   313,   314,   421,
     306,   307,   308,   334,   465,   335,   311,   466,   313,   314,
     306,   307,   308,   336,   337,   124,   311,   125,   313,   314,
     133,   191,   192,   193,   194,   412,   413,   191,   192,   193,
     194,   376,   126,   195,   127,   134,   135,   196,   112,   195,
     382,   144,   381,   196,   204,   136,    10,    11,   205,   206,
     137,   138,   263,   480,   261,   139,   306,   307,   308,   147,
     265,   140,   311,   531,   313,   314,   112,   141,   320,   321,
     322,   142,   204,   143,    10,    11,    12,   206,   306,   307,
     308,   146,   309,   310,   311,   312,   313,   314,   315,   112,
     158,   160,   164,   165,   167,   204,   168,    10,    11,    12,
     175,   306,   307,   308,   176,   182,   183,   311,   467,   313,
     314,   240,   241,   242,   243,   244,   245,   246,   184,   185,
     186,   187,   188,   189,   190,   203,   382,   214,   215,   218,
     221,   219,   222,   223,   226,   228,   234,   227,   235,   229,
     230,   236,   237,   247,   250,   251,   252,   257,   112,   248,
     249,   264,   269,   270,   271,   272,   277,   273,   281,   278,
     283,   496,   284,   498,   268,   500,   288,   502,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   291,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,   287,   290,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   303,   304,   305,   329,
     302,   330,   331,   342,   344,   355,   346,   356,   341,   358,
     357,   359,   360,   364,   365,   362,   363,   366,   367,   368,
     361,   369,   370,   371,   378,   384,   383,   385,   386,   388,
     387,   390,   389,   391,   392,   393,   394,   395,   396,   397,
     398,   400,   401,   405,   406,   399,   408,   409,   407,   410,
     411,   424,   431,   426,   427,   442,   445,   415,   446,   447,
     448,   449,   443,   450,   425,   452,   457,   456,   451,   462,
     469,   453,   470,   455,   460,   479,   461,   468,   472,   481,
     471,   485,   474,   473,   476,   503,   475,   482,   477,   478,
     483,   484,   521,   493,   494,   486,   333,   377,   380,   487,
     231,   159,   512,   495,   497,   499,   501,   504,   262,   505,
     506,   507,   508,   511,   339,   522,   516,   224,   513,   517,
       0,   514,   518,   515,   519,   520,   523,     0,     0,   524,
       0,     0,     0,     0,   525,   526,     0,   532,     0,     0,
       0,     0,     0,     0,   527,     0,     0,     0,     0,     0,
       0,     0,     0,   145
};

static const yytype_int16 yycheck[] =
{
     160,   255,   175,   257,     0,     7,   404,   126,   127,     0,
       4,     5,     4,   384,   174,   291,   292,   293,   294,   295,
     296,   297,   298,     4,     4,     5,     5,     4,   415,     4,
       5,    69,     4,    69,     4,     8,    69,     4,   224,   421,
      10,     4,     5,    37,    74,    74,     5,    76,    74,    87,
      74,    87,     4,   239,    87,    81,    86,    86,    30,    65,
      86,    65,    86,   223,   318,   206,   207,    75,    74,    34,
      35,    36,   326,     4,   328,    40,   236,    42,    43,    76,
      69,    46,    47,    48,    81,     3,     4,    81,    77,    66,
      67,    66,    69,    89,    86,   466,    73,    74,    89,   486,
      77,    81,    75,    82,   277,    86,   488,    70,   227,    86,
     283,    70,   114,    65,   390,   391,   392,   393,   394,   395,
     396,   397,    87,    66,   265,   285,    69,    65,    34,    35,
      36,   529,    38,    39,    40,    41,    42,    43,    44,    34,
      35,    36,   374,   375,    81,    40,    65,    42,    43,    86,
      34,    35,    36,   270,    66,   272,    40,    69,    42,    43,
      34,    35,    36,     4,     5,    65,    40,    65,    42,    43,
      75,    33,    34,    35,    36,     4,     5,    33,    34,    35,
      36,    87,    65,    45,    65,     4,    65,    49,     4,    45,
     444,     0,    87,    49,    10,    65,    12,    13,    14,    15,
      65,    65,   204,    87,    66,    65,    34,    35,    36,     8,
     206,    65,    40,    87,    42,    43,     4,    65,    46,    47,
      48,    65,    10,    65,    12,    13,    14,    15,    34,    35,
      36,    65,    38,    39,    40,    41,    42,    43,    44,     4,
       4,    81,     4,     4,     4,    10,     4,    12,    13,    14,
       4,    34,    35,    36,    67,     4,     4,    40,   431,    42,
      43,   184,   185,   186,   187,   188,   189,   190,     4,     4,
       4,     4,     4,     4,     4,     4,   530,    74,     4,    66,
      74,    77,    66,    81,    69,    66,     8,    69,     5,    69,
      69,    69,    66,     4,     4,     4,     4,    86,     4,    76,
      76,    17,    73,    69,    67,    75,     4,    76,     4,    82,
       4,   471,     3,   473,    86,   475,     4,   477,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    69,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    74,    74,    69,    69,    69,    69,
      69,    69,    69,    65,     3,     3,    65,    65,     5,    74,
      76,    67,    86,    66,    69,     4,    77,    74,    82,     5,
      74,     4,     4,     4,     4,    76,    76,     4,    76,     4,
      82,    76,    76,    76,    76,    65,    77,    74,    74,     3,
      69,    69,    77,    69,    69,    69,    69,    69,    69,    69,
      66,    66,    69,     3,     3,    74,     4,     4,    76,     4,
       4,    74,     4,    74,    74,     4,    74,    81,    74,     5,
      65,    65,    81,    65,    86,     8,    76,    82,    74,     4,
       3,    74,    66,    74,    74,     5,    74,    74,    66,    74,
      69,     4,    66,    69,    66,     5,    69,    66,    69,    69,
      66,    66,     5,    66,    66,    73,   269,   318,   326,    76,
     173,   118,   490,    74,    74,    74,    74,    73,   202,    74,
      74,    74,    74,    74,   275,    82,    66,   165,    74,    66,
      -1,    74,    66,    74,    66,    66,    74,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    74,    74,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    90,    91,    92,    93,
      94,    95,    96,    97,    98,   105,   106,   107,   108,   109,
     110,   115,   116,   117,   118,   119,   120,   145,   146,   147,
     148,   149,     4,    86,   103,     4,   150,    65,    75,     4,
       4,    65,    65,    65,    65,    65,    65,    65,     4,   112,
     113,   114,   116,    75,     4,    65,    65,    65,    65,    65,
      65,    65,    65,    65,     0,    94,    65,     8,    66,    67,
      69,    73,    74,    77,    86,   103,     4,    86,     4,   112,
      81,   160,    65,    74,     4,     4,   156,     4,     4,   156,
       3,   111,   156,     8,    75,     4,    67,     4,     5,    70,
     161,   162,     4,     4,     4,     4,     4,     4,     4,     4,
       4,    33,    34,    35,    36,    45,    49,   130,   133,   140,
     141,   143,   144,     4,    10,    14,    15,    92,    99,   100,
     101,   102,   103,   104,    74,     4,   151,   152,    66,    77,
     161,    74,    66,    81,   158,   159,    69,    69,    66,    69,
      69,   113,   161,   160,     8,     5,    69,    66,   157,   158,
     157,   157,   157,   157,   157,   157,   157,     4,    76,    76,
       4,     4,     4,    74,    81,    86,   134,    86,    74,    86,
     142,    66,   143,   103,    17,    92,   102,   102,    86,    73,
      69,    67,    75,    76,   153,    69,    87,     4,    82,   161,
     159,     4,   156,     4,     3,    69,    77,    74,     4,   161,
      74,    69,    69,    69,    69,    69,    69,    69,    69,    65,
       3,     3,    76,    65,    65,     5,    34,    35,    36,    38,
      39,    40,    41,    42,    43,    44,   125,   128,   129,   131,
      46,    47,    48,   131,   137,   138,   139,   131,   132,    74,
      67,    86,   102,    99,   100,   100,     4,     5,   154,   152,
     160,    82,    66,   160,    69,   161,    77,   162,   162,   162,
     162,   162,   162,   162,   162,     4,    74,    74,     5,     4,
       4,    82,    76,    76,     4,     4,     4,    76,     4,    76,
      76,    76,    76,    81,   126,   127,    87,   128,    76,    87,
     138,    87,   131,    77,    65,    74,    74,    69,     3,    77,
      69,    69,    69,    69,    69,    69,    69,    69,    66,    74,
      66,    69,    74,    76,    86,     3,     3,    76,     4,     4,
       4,     4,     4,     5,    37,    81,   121,   122,   123,     5,
      82,    86,   122,   122,    74,    86,    74,    74,    66,   154,
     155,     4,    66,    69,   162,   162,   162,   162,   162,   162,
     162,   162,     4,    81,   132,    74,    74,     5,    65,    65,
      65,    74,     8,    74,   121,    74,    82,    76,   123,   124,
      74,    74,     4,   135,   136,    66,    69,   160,    74,     3,
      66,    69,    66,    69,    66,    69,    66,    69,    69,     5,
      87,    74,    66,    66,    66,     4,    73,    76,    69,    87,
      69,    87,   154,    66,    66,    74,   161,    74,   161,    74,
     161,    74,   161,     5,    73,    74,    74,    74,    74,   121,
     123,    74,   135,    74,    74,    74,    66,    66,    66,    66,
      66,     5,    82,    74,    74,    74,    74,    82,    74,    86,
     132,    87,    74
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
// YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 203 "scgrammer.y"
    { /*clean up!*/ scparser_EmitPrefix(); ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 217 "scgrammer.y"
    { ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 222 "scgrammer.y"
    { ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 223 "scgrammer.y"
    { ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 226 "scgrammer.y"
    { ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 227 "scgrammer.y"
    { ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 228 "scgrammer.y"
    { ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 229 "scgrammer.y"
    { ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 230 "scgrammer.y"
    { ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 231 "scgrammer.y"
    { ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 232 "scgrammer.y"
    { ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 233 "scgrammer.y"
    { ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 234 "scgrammer.y"
    { ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 235 "scgrammer.y"
    { ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 236 "scgrammer.y"
    { ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 237 "scgrammer.y"
    { ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 238 "scgrammer.y"
    { ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 239 "scgrammer.y"
    { ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 240 "scgrammer.y"
    { ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 241 "scgrammer.y"
    { ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 242 "scgrammer.y"
    { ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 243 "scgrammer.y"
    { ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 244 "scgrammer.y"
    { ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 245 "scgrammer.y"
    { ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 246 "scgrammer.y"
    { ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 247 "scgrammer.y"
    { ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 248 "scgrammer.y"
    { ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 249 "scgrammer.y"
    { ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 250 "scgrammer.y"
    { ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 251 "scgrammer.y"
    { ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 252 "scgrammer.y"
    { ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 253 "scgrammer.y"
    { ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 254 "scgrammer.y"
    { ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 255 "scgrammer.y"
    { ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 256 "scgrammer.y"
    { ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 257 "scgrammer.y"
    { ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 258 "scgrammer.y"
    { ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 259 "scgrammer.y"
    { ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 260 "scgrammer.y"
    { ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 261 "scgrammer.y"
    { SCFree((yyvsp[(1) - (1)].string)); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 262 "scgrammer.y"
    { scparser_symbol((yyvsp[(1) - (1)].string)); SCFree((yyvsp[(1) - (1)].string)); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 263 "scgrammer.y"
    { SCFree((yyvsp[(1) - (1)].string)); ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 264 "scgrammer.y"
    { ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 265 "scgrammer.y"
    { ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 266 "scgrammer.y"
    { ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 267 "scgrammer.y"
    { ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 268 "scgrammer.y"
    { ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 269 "scgrammer.y"
    { ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 272 "scgrammer.y"
    {
			  scparser_EmitPrefix();
			  scparser_PrefixCat(sclextext,sclexleng);  /* Emit as independent TEXT */
			  scparser_call(1,"auto",sclextext);
			;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 279 "scgrammer.y"
    { scparser_call(-1,"module",(yyvsp[(3) - (4)].string)); ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 280 "scgrammer.y"
    { scparser_call(1,"module","sc_main"); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 283 "scgrammer.y"
    { scparser_call(-1,"module_continued",(yyvsp[(3) - (4)].string)); ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 286 "scgrammer.y"
    { scparser_call(-1,"class",(yyvsp[(2) - (3)].string)); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 287 "scgrammer.y"
    { scparser_call(-2,"class",(yyvsp[(2) - (5)].string),(yyvsp[(4) - (5)].string)); ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 288 "scgrammer.y"
    { scparser_call(-1,"module",(yyvsp[(2) - (6)].string)); ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 289 "scgrammer.y"
    { ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 290 "scgrammer.y"
    { ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 291 "scgrammer.y"
    { ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 292 "scgrammer.y"
    { ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 293 "scgrammer.y"
    { ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 294 "scgrammer.y"
    { ;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 295 "scgrammer.y"
    { ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 298 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 299 "scgrammer.y"
    { (yyval.string) = scstrjoin3sis ((yyvsp[(1) - (3)].string),":",(yyvsp[(3) - (3)].string)); ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 302 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 303 "scgrammer.y"
    { (yyval.string) = scstrjoin3sis ((yyvsp[(1) - (3)].string),",",(yyvsp[(3) - (3)].string)); ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 306 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 307 "scgrammer.y"
    { (yyval.string) = (yyvsp[(2) - (2)].string); ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 308 "scgrammer.y"
    { (yyval.string) = (yyvsp[(2) - (2)].string); ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 309 "scgrammer.y"
    { (yyval.string) = (yyvsp[(3) - (3)].string); ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 312 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 313 "scgrammer.y"
    { (yyval.string) = scstrjoin4sisi ((yyvsp[(1) - (4)].string),"<",(yyvsp[(3) - (4)].string),">"); ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 316 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 317 "scgrammer.y"
    { (yyval.string) = scstrjoin3sis ((yyvsp[(1) - (3)].string),"::",(yyvsp[(3) - (3)].string)); ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 320 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 321 "scgrammer.y"
    { (yyval.string) = scstrjoin2si ((yyvsp[(1) - (2)].string),"*"); ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 322 "scgrammer.y"
    { (yyval.string) = (yyvsp[(2) - (2)].string); ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 323 "scgrammer.y"
    { (yyval.string) = scstrjoin2si ((yyvsp[(2) - (3)].string),"*"); ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 326 "scgrammer.y"
    { scparser_call(-1,"ctor",(yyvsp[(3) - (4)].string)); ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 330 "scgrammer.y"
    { scparser_call(-2,"cell",(yyvsp[(3) - (5)].string),(yyvsp[(5) - (5)].string)); ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 333 "scgrammer.y"
    { scparser_call(-2,"cell_decl",(yyvsp[(3) - (7)].string),(yyvsp[(5) - (7)].string)); ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 336 "scgrammer.y"
    { scparser_call(-5,"pin",(yyvsp[(3) - (11)].string),(yyvsp[(5) - (11)].string),(yyvsp[(6) - (11)].string),(yyvsp[(8) - (11)].string),(yyvsp[(9) - (11)].string)); ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 339 "scgrammer.y"
    { scparser_call(-4,"signal",(yyvsp[(1) - (7)].string),(yyvsp[(3) - (7)].string),(yyvsp[(5) - (7)].string),(yyvsp[(6) - (7)].string)); ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 343 "scgrammer.y"
    { scparser_call(-3,"pin_template",(yyvsp[(3) - (9)].string),(yyvsp[(5) - (9)].string),(yyvsp[(7) - (9)].string)); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 345 "scgrammer.y"
    { scparser_call(-4,"pin_template",(yyvsp[(3) - (11)].string),(yyvsp[(5) - (11)].string),(yyvsp[(7) - (11)].string),(yyvsp[(9) - (11)].string)); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 348 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 349 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 353 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 354 "scgrammer.y"
    { char *cp=malloc(strlen((yyvsp[(1) - (2)].string))+5);
			  strcpy (cp,(yyvsp[(1) - (2)].string)); strcat(cp,"*");
			  SCFree ((yyvsp[(1) - (2)].string));
			  (yyval.string)=cp; ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 360 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 361 "scgrammer.y"
    { (yyval.string) = scstrjoin3sis ((yyvsp[(1) - (3)].string),"::",(yyvsp[(3) - (3)].string)); ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 365 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 366 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 367 "scgrammer.y"
    { char *cp=malloc(strlen((yyvsp[(1) - (4)].string))+strlen((yyvsp[(3) - (4)].string))+5);
						  strcpy(cp,(yyvsp[(1) - (4)].string)); strcat(cp,"<");strcat(cp,(yyvsp[(3) - (4)].string));strcat(cp,">");
						  SCFree ((yyvsp[(1) - (4)].string)); SCFree ((yyvsp[(3) - (4)].string));
						  (yyval.string)=cp; ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 371 "scgrammer.y"
    {
						  char *cp=malloc(strlen((yyvsp[(1) - (6)].string))+strlen((yyvsp[(3) - (6)].string))+strlen((yyvsp[(5) - (6)].string))+6);
						  strcpy(cp,(yyvsp[(1) - (6)].string));  strcat(cp,"<"); strcat(cp,(yyvsp[(3) - (6)].string));
						  strcat(cp,","); strcat(cp,(yyvsp[(5) - (6)].string));  strcat(cp,">");
						  SCFree ((yyvsp[(1) - (6)].string)); SCFree ((yyvsp[(3) - (6)].string)); SCFree ((yyvsp[(5) - (6)].string));
						  (yyval.string)=cp; ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 380 "scgrammer.y"
    { scparser_call(-1,"var_decl",(yyvsp[(1) - (1)].string)); ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 383 "scgrammer.y"
    {
						  char *cp=malloc(6+strlen((yyvsp[(3) - (6)].string))+strlen((yyvsp[(5) - (6)].string))+6);
						  strcpy(cp,"sp_ui<");  strcat(cp,(yyvsp[(3) - (6)].string));
						  strcat(cp,","); strcat(cp,(yyvsp[(5) - (6)].string));  strcat(cp,">");
						  SCFree ((yyvsp[(3) - (6)].string)); SCFree ((yyvsp[(5) - (6)].string));
						  (yyval.string)=cp; ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 392 "scgrammer.y"
    {
						  {char *cp = strrchr((yyvsp[(1) - (4)].string),'_'); if (cp) *cp='\0';} /* Drop _clk */
						  scparser_call(4,"signal",(yyvsp[(1) - (4)].string),"sc_clock",(yyvsp[(2) - (4)].string),(yyvsp[(3) - (4)].string));
						  SCFree((yyvsp[(1) - (4)].string)); SCFree((yyvsp[(2) - (4)].string)); SCFree((yyvsp[(3) - (4)].string));;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 398 "scgrammer.y"
    {
						  scparser_call(3,"signal",(yyvsp[(1) - (3)].string),"sc_clock",(yyvsp[(2) - (3)].string));
						  SCFree((yyvsp[(1) - (3)].string)); SCFree((yyvsp[(2) - (3)].string));;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 404 "scgrammer.y"
    { SCFree((yyvsp[(1) - (2)].string)); ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 405 "scgrammer.y"
    { SCFree((yyvsp[(1) - (3)].string)); scparser_symbol((yyvsp[(2) - (3)].string)); SCFree((yyvsp[(2) - (3)].string));;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 408 "scgrammer.y"
    { scparser_call(1,"preproc_sp",sclextext);;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 418 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 419 "scgrammer.y"
    { (yyval.string) = scstrjoin3sis ((yyvsp[(1) - (3)].string),"::",(yyvsp[(3) - (3)].string)); ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 422 "scgrammer.y"
    { scparser_call(3,"coverpoint","binrange", (yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].string)); SCFree((yyvsp[(2) - (5)].string)); SCFree((yyvsp[(4) - (5)].string)); ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 425 "scgrammer.y"
    { scparser_call(2,"coverpoint","binval", (yyvsp[(1) - (1)].string)); SCFree((yyvsp[(1) - (1)].string)); ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 426 "scgrammer.y"
    { ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 429 "scgrammer.y"
    { ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 430 "scgrammer.y"
    { ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 433 "scgrammer.y"
    { scparser_call(2,"coverpoint","normal", (yyvsp[(2) - (2)].string)); SCFree((yyvsp[(2) - (2)].string)); ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 434 "scgrammer.y"
    { scparser_call(2,"coverpoint","illegal", (yyvsp[(2) - (2)].string)); SCFree((yyvsp[(2) - (2)].string)); ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 435 "scgrammer.y"
    { scparser_call(2,"coverpoint","ignore", (yyvsp[(2) - (2)].string)); SCFree((yyvsp[(2) - (2)].string)); ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 438 "scgrammer.y"
    { scparser_call(1,"coverpoint","multi_begin"); ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 441 "scgrammer.y"
    { scparser_call(2,"coverpoint","multi_begin_num",(yyvsp[(2) - (4)].string)); SCFree((yyvsp[(2) - (4)].string));;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 445 "scgrammer.y"
    { scparser_call(1,"coverpoint","default"); ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 446 "scgrammer.y"
    { scparser_call(1,"coverpoint","single"); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 447 "scgrammer.y"
    { scparser_call(1,"coverpoint","multi_end"); ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 448 "scgrammer.y"
    { scparser_call(1,"coverpoint","multi_auto_end"); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 449 "scgrammer.y"
    { scparser_call(1,"coverpoint","multi_auto_end"); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 450 "scgrammer.y"
    { scparser_call(2,"coverpoint","enum", (yyvsp[(3) - (4)].string)); SCFree((yyvsp[(3) - (4)].string)); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 451 "scgrammer.y"
    { ;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 454 "scgrammer.y"
    { ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 455 "scgrammer.y"
    { ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 462 "scgrammer.y"
    { scparser_call(1,"covergroup_description",(yyvsp[(3) - (4)].string)); SCFree((yyvsp[(3) - (4)].string));;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 463 "scgrammer.y"
    { scparser_call(2,"covergroup_option",(yyvsp[(2) - (5)].string),(yyvsp[(4) - (5)].string)); SCFree((yyvsp[(2) - (5)].string)); SCFree((yyvsp[(4) - (5)].string));;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 464 "scgrammer.y"
    { scparser_call(1,"covergroup_page",(yyvsp[(3) - (4)].string)); SCFree((yyvsp[(3) - (4)].string));;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 468 "scgrammer.y"
    { scparser_call(2,"coverpoint","description",(yyvsp[(3) - (4)].string)); SCFree((yyvsp[(3) - (4)].string));;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 469 "scgrammer.y"
    { scparser_call(3,"coverpoint", "option",(yyvsp[(2) - (5)].string),(yyvsp[(4) - (5)].string)); SCFree((yyvsp[(2) - (5)].string)); SCFree((yyvsp[(4) - (5)].string));;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 470 "scgrammer.y"
    { scparser_call(2,"coverpoint","page",(yyvsp[(3) - (4)].string)); SCFree((yyvsp[(3) - (4)].string));;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 471 "scgrammer.y"
    { scparser_call(2,"coverpoint","limit_func", (yyvsp[(3) - (6)].string)); SCFree((yyvsp[(3) - (6)].string)); ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 472 "scgrammer.y"
    { scparser_call(2,"coverpoint","ignore_func", (yyvsp[(3) - (6)].string)); SCFree((yyvsp[(3) - (6)].string)); ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 473 "scgrammer.y"
    { scparser_call(2,"coverpoint","illegal_func", (yyvsp[(3) - (6)].string)); SCFree((yyvsp[(3) - (6)].string)); ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 476 "scgrammer.y"
    { ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 477 "scgrammer.y"
    { ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 483 "scgrammer.y"
    { scparser_call(2,"coverpoint_begin",(yyvsp[(2) - (2)].string),(yyvsp[(2) - (2)].string)); SCFree((yyvsp[(2) - (2)].string)); ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 484 "scgrammer.y"
    { scparser_call(-2,"coverpoint_begin",(yyvsp[(2) - (5)].string),(yyvsp[(4) - (5)].string)); ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 487 "scgrammer.y"
    { scparser_call(1,"coverpoint","standard"); ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 488 "scgrammer.y"
    { scparser_call(2,"coverpoint","standard_bins", (yyvsp[(2) - (4)].string)); SCFree((yyvsp[(2) - (4)].string)); ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 489 "scgrammer.y"
    { scparser_call(2,"coverpoint","standard_bins", (yyvsp[(2) - (7)].string)); SCFree((yyvsp[(2) - (7)].string)); ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 490 "scgrammer.y"
    { scparser_call(4,"coverpoint","standard_bins_range", (yyvsp[(2) - (10)].string), (yyvsp[(6) - (10)].string), (yyvsp[(8) - (10)].string)); SCFree((yyvsp[(2) - (10)].string)); ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 491 "scgrammer.y"
    { scparser_call(4,"coverpoint","standard_bins_range", (yyvsp[(2) - (13)].string), (yyvsp[(6) - (13)].string), (yyvsp[(8) - (13)].string)); SCFree((yyvsp[(2) - (13)].string)); ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 492 "scgrammer.y"
    { scparser_call(1,"coverpoint","bins"); ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 498 "scgrammer.y"
    { scparser_call(2,"cross","item",(yyvsp[(1) - (1)].string)); SCFree((yyvsp[(1) - (1)].string)); ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 501 "scgrammer.y"
    { ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 502 "scgrammer.y"
    { ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 505 "scgrammer.y"
    { scparser_call(1,"cross","start_rows"); ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 506 "scgrammer.y"
    { scparser_call(1,"cross","start_cols"); ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 507 "scgrammer.y"
    { scparser_call(1,"cross","start_table"); ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 510 "scgrammer.y"
    {;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 511 "scgrammer.y"
    { ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 514 "scgrammer.y"
    { ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 515 "scgrammer.y"
    { ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 518 "scgrammer.y"
    { scparser_call(2,"cross_begin",(yyvsp[(2) - (2)].string),(yyvsp[(2) - (2)].string)); SCFree((yyvsp[(2) - (2)].string)); ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 519 "scgrammer.y"
    { scparser_call(-2,"cross_begin",(yyvsp[(2) - (5)].string),(yyvsp[(4) - (5)].string)); ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 525 "scgrammer.y"
    { scparser_call(-4,"coverpoint_window",(yyvsp[(2) - (9)].string),(yyvsp[(4) - (9)].string),(yyvsp[(6) - (9)].string),(yyvsp[(8) - (9)].string));;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 528 "scgrammer.y"
    { ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 529 "scgrammer.y"
    { ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 535 "scgrammer.y"
    { scparser_call(0,"coverpoint_end"); ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 536 "scgrammer.y"
    { scparser_call(0,"coverpoint_end"); ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 537 "scgrammer.y"
    { scparser_call(0,"coverpoint_end"); ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 539 "scgrammer.y"
    { ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 542 "scgrammer.y"
    { ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 543 "scgrammer.y"
    { ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 546 "scgrammer.y"
    { scparser_call(0,"covergroup_end"); ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 549 "scgrammer.y"
    { scparser_call(-1,"covergroup_begin",(yyvsp[(2) - (2)].string)); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 555 "scgrammer.y"
    { scparser_call(-1,"coversample",(yyvsp[(3) - (5)].string)); ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 562 "scgrammer.y"
    { scparser_call(4,"signal","sp_traced",(yyvsp[(2) - (5)].string),(yyvsp[(3) - (5)].string),(yyvsp[(4) - (5)].string));
			  SCFree((yyvsp[(2) - (5)].string)); SCFree((yyvsp[(3) - (5)].string)); SCFree((yyvsp[(4) - (5)].string));}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 565 "scgrammer.y"
    { scparser_call(6,"signal","sp_traced_vl","uint32_t",(yyvsp[(3) - (10)].string),(yyvsp[(4) - (10)].string),(yyvsp[(6) - (10)].string),(yyvsp[(8) - (10)].string));
			  SCFree((yyvsp[(3) - (10)].string)); SCFree((yyvsp[(4) - (10)].string)); SCFree((yyvsp[(6) - (10)].string)); SCFree((yyvsp[(8) - (10)].string));;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 568 "scgrammer.y"
    { scparser_call(6,"signal","sp_traced_vl","uint32_t",(yyvsp[(3) - (12)].string),(yyvsp[(4) - (12)].string),(yyvsp[(6) - (12)].string),(yyvsp[(8) - (12)].string));
			  SCFree((yyvsp[(3) - (12)].string)); SCFree((yyvsp[(4) - (12)].string)); SCFree((yyvsp[(6) - (12)].string)); SCFree((yyvsp[(8) - (12)].string)); SCFree((yyvsp[(10) - (12)].string));;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 571 "scgrammer.y"
    { scparser_call(6,"signal","vl_inout","uint32_t",(yyvsp[(3) - (10)].string),(yyvsp[(4) - (10)].string),(yyvsp[(6) - (10)].string),(yyvsp[(8) - (10)].string));
			  SCFree((yyvsp[(3) - (10)].string)); SCFree((yyvsp[(4) - (10)].string)); SCFree((yyvsp[(6) - (10)].string)); SCFree((yyvsp[(8) - (10)].string));;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 574 "scgrammer.y"
    { scparser_call(6,"signal","vl_inout","uint32_t",(yyvsp[(3) - (12)].string),(yyvsp[(4) - (12)].string),(yyvsp[(6) - (12)].string),(yyvsp[(8) - (12)].string));
			  SCFree((yyvsp[(3) - (12)].string)); SCFree((yyvsp[(4) - (12)].string)); SCFree((yyvsp[(6) - (12)].string)); SCFree((yyvsp[(8) - (12)].string)); SCFree((yyvsp[(10) - (12)].string));;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 577 "scgrammer.y"
    { scparser_call(6,"signal","vl_in","uint32_t",(yyvsp[(3) - (10)].string),(yyvsp[(4) - (10)].string),(yyvsp[(6) - (10)].string),(yyvsp[(8) - (10)].string));
			  SCFree((yyvsp[(3) - (10)].string)); SCFree((yyvsp[(4) - (10)].string)); SCFree((yyvsp[(6) - (10)].string)); SCFree((yyvsp[(8) - (10)].string));;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 580 "scgrammer.y"
    { scparser_call(6,"signal","vl_in","uint32_t",(yyvsp[(3) - (12)].string),(yyvsp[(4) - (12)].string),(yyvsp[(6) - (12)].string),(yyvsp[(8) - (12)].string));
			  SCFree((yyvsp[(3) - (12)].string)); SCFree((yyvsp[(4) - (12)].string)); SCFree((yyvsp[(6) - (12)].string)); SCFree((yyvsp[(8) - (12)].string)); SCFree((yyvsp[(10) - (12)].string));;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 583 "scgrammer.y"
    { scparser_call(6,"signal","vl_out","uint32_t",(yyvsp[(3) - (10)].string),(yyvsp[(4) - (10)].string),(yyvsp[(6) - (10)].string),(yyvsp[(8) - (10)].string));
			  SCFree((yyvsp[(3) - (10)].string)); SCFree((yyvsp[(4) - (10)].string)); SCFree((yyvsp[(6) - (10)].string)); SCFree((yyvsp[(8) - (10)].string));;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 586 "scgrammer.y"
    { scparser_call(6,"signal","vl_out","uint32_t",(yyvsp[(3) - (12)].string),(yyvsp[(4) - (12)].string),(yyvsp[(6) - (12)].string),(yyvsp[(8) - (12)].string));
			  SCFree((yyvsp[(3) - (12)].string)); SCFree((yyvsp[(4) - (12)].string)); SCFree((yyvsp[(6) - (12)].string)); SCFree((yyvsp[(8) - (12)].string)); SCFree((yyvsp[(10) - (12)].string));;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 593 "scgrammer.y"
    { SCFree (scParserLex.enumname); ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 594 "scgrammer.y"
    { SCFree (scParserLex.enumname); ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 596 "scgrammer.y"
    { scParserLex.enumname = (yyvsp[(1) - (1)].string); ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 597 "scgrammer.y"
    { scParserLex.enumname = NULL; ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 599 "scgrammer.y"
    { ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 600 "scgrammer.y"
    { ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 602 "scgrammer.y"
    {
			if (scParserLex.enumname) scparser_call(3,"enum_value",scParserLex.enumname,(yyvsp[(1) - (2)].string),(yyvsp[(2) - (2)].string));
			SCFree((yyvsp[(1) - (2)].string)); SCFree((yyvsp[(2) - (2)].string)); ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 606 "scgrammer.y"
    { (yyval.string) = (yyvsp[(2) - (2)].string); ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 607 "scgrammer.y"
    { (yyval.string) = strdup(""); ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 609 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 610 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 611 "scgrammer.y"
    { (yyval.string) = scstrjoin2si((yyvsp[(1) - (3)].string),"()"); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 612 "scgrammer.y"
    { (yyval.string) = scstrjoin4sisi((yyvsp[(1) - (4)].string),"(",(yyvsp[(3) - (4)].string),")"); ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 614 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 615 "scgrammer.y"
    { (yyval.string) = scstrjoin3sis((yyvsp[(1) - (3)].string),",",(yyvsp[(3) - (3)].string)); ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 620 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 621 "scgrammer.y"
    { (yyval.string) = scstrjoin2ss((yyvsp[(1) - (2)].string),(yyvsp[(2) - (2)].string)); ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 624 "scgrammer.y"
    { (yyval.string) = strdup(""); ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 625 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 628 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 629 "scgrammer.y"
    { (yyval.string) = scstrjoin2ss((yyvsp[(1) - (2)].string),(yyvsp[(2) - (2)].string)); ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 632 "scgrammer.y"
    { char *cp=malloc(strlen((yyvsp[(2) - (3)].string))+5);
						  strcpy(cp,"["); strcat(cp,(yyvsp[(2) - (3)].string)); strcat(cp,"]");
						  SCFree ((yyvsp[(2) - (3)].string));
						  (yyval.string)=cp; ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 638 "scgrammer.y"
    { (yyval.string) = strdup(""); ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 639 "scgrammer.y"
    { (yyval.string) = (yyvsp[(2) - (3)].string); ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 642 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 643 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 644 "scgrammer.y"
    { (yyval.string) = scstrjoin3sis ((yyvsp[(1) - (3)].string),":",(yyvsp[(3) - (3)].string)); ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 647 "scgrammer.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 648 "scgrammer.y"
    { (yyval.string) = scstrjoin2is ("-",(yyvsp[(2) - (2)].string)); ;}
    break;



/* Line 1455 of yacc.c  */
#line 3451 "scgrammer.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 651 "scgrammer.y"


const char *vlgrammer_tokename (int toke) {
    return (yytname[toke]);
}

